PROGRAM test_mtime
  USE mtime_hl

  CALL setCalendar(proleptic_gregorian)
  CALL test1 ()
  CALL test2 ()

CONTAINS

  SUBROUTINE test1 ()
    TYPE(t_timedelta) :: dt, t0, t1, t2, t3
    
    WRITE (0,*) "test1:"
    dt = t_timedelta("PT24.000S")
    t0 = t_timedelta("PT3600.000S")
    t1 = t_timedelta("PT3600.000S") + dt
    t2 = t_timedelta("PT60M")       + dt
    t3 = t_timedelta("PT1H")        + dt

    WRITE(0,*) "  t0 : ", t0%toString(), "Reference"
    WRITE(0,*) "  dt : ", dt%toString(), "Modification"
    WRITE(0,*) "  t1 : ", t1%toString(), "???"
    WRITE(0,*) "  t2 : ", t2%toString(), "OK"
    WRITE(0,*) "  t3 : ", t3%toString(), "OK"
  END SUBROUTINE test1

  !-
  SUBROUTINE test2 ()
    TYPE(t_event)       :: mec_Event
    TYPE(t_datetime)    :: mec_RefDate
    TYPE(t_datetime)    :: mec_StartDate
    TYPE(t_datetime)    :: mec_EndDate
    TYPE(t_timedelta)   :: mec_Start
    TYPE(t_timedelta)   :: mec_Stop
    TYPE(t_timedelta)   :: mec_Interval
    TYPE(t_timedelta)   :: time_step
    TYPE(t_eventGroup)  :: mec_Events
    TYPE(t_datetime)    :: mtime
    INTEGER             :: i
    
    mec_Start      = t_timeDelta("PT0S")
    mec_Stop       = t_timeDelta("PT3600S")
    mec_Interval   = t_timeDelta("PT300S")
    
    time_step      = t_timeDelta("PT24S")
    
    mec_RefDate    = t_datetime ("2016-05-29T00:00:00.000")
    mec_StartDate  = mec_RefDate   + mec_Start
    mec_EndDate    = mec_RefDate   + mec_Stop
    
    WRITE (0,*)
    WRITE (0,*) "test2:"
    WRITE (0,*) "Model time step   : ",   time_step%toString()
    WRITE (0,*) "MEC start time    : ",   mec_Start%toString()
    WRITE (0,*) "MEC stop time     : ",   mec_Stop%toString()
    WRITE (0,*) "MEC interval      : ",   mec_Interval%toString()
    WRITE (0,*) "MEC reference date: ",   mec_RefDate%toString()
    WRITE (0,*) "MEC start date    : ",   mec_StartDate%toString()
    WRITE (0,*) "MEC end date      : ",   mec_EndDate%toString()
    WRITE (0,*)
    WRITE (0,*) "Checking event management"

    mec_Events     =  t_eventGroup('mecEventGroup')
    mec_EndDate    = mec_EndDate + time_step
    mec_Event      =  t_event('mec', mec_RefDate, mec_StartDate, mec_EndDate, mec_Interval)
    
    CALL mec_Events%append(mec_Event)
    
    mtime = mec_StartDate
    i = 0
    DO
      IF (mec_Event%isActive(mtime, plus_slack=time_step)) THEN
        i = i + 1
        WRITE (0,*) "MEC will be called on: ", TRIM (mtime%toString())
      END IF
      IF (mtime >= mec_EndDate) THEN
        EXIT
      END IF
      mtime = mtime + time_step
    END DO
    WRITE(0,*) "check_dace_timer: total MEC calls:", i, "(expected: 13)"
  END SUBROUTINE test2

END PROGRAM test_mtime
