module mtime_constants

  use, intrinsic :: iso_c_binding, only: c_int
  
  implicit none

  public 

  enum, bind(c)
    enumerator :: calendar_not_set    = 0   ! calendar is not defined yet
    enumerator :: proleptic_gregorian = 1   ! proleptic Gregorian calendar
    enumerator :: year_of_365_days    = 2   ! 365 day year without leap years
    enumerator :: year_of_360_days    = 3   ! 360 day year with 30 day months
  end enum
  
  integer(c_int), bind(c,name='NO_OF_SEC_IN_A_DAY') :: no_of_sec_in_a_day
  integer(c_int), bind(c,name='NO_OF_SEC_IN_A_HOUR') :: no_of_sec_in_a_hour
  integer(c_int), bind(c,name='NO_OF_SEC_IN_A_MINUTE') :: no_of_sec_in_a_minute
  
  integer(c_int), bind(c,name='NO_OF_MS_IN_A_DAY') :: no_of_ms_in_a_day
  integer(c_int), bind(c,name='NO_OF_MS_IN_HALF_DAY') :: no_of_ms_in_half_day
  integer(c_int), bind(c,name='NO_OF_MS_IN_A_HOUR') :: no_of_ms_in_a_hour
  integer(c_int), bind(c,name='NO_OF_MS_IN_A_MINUTE') :: no_of_ms_in_a_minute
  integer(c_int), bind(c,name='NO_OF_MS_IN_A_SECOND') :: no_of_ms_in_a_second

  
  !> provides a string length for toString
  integer, parameter :: max_calendar_str_len = 32
  
  !> provides a string length for toString
  integer, parameter :: max_date_str_len = 32

  !> provides a string length for toString
  integer, parameter :: max_datetime_str_len = 32

  !> provides a string length for toString
  integer, parameter :: max_time_str_len = 32

  !> provides a string length for toString
  integer, parameter :: max_julianday_str_len = 32

  !> provides a string length for toString
  integer, parameter :: max_timedelta_str_len = 32

  !> provides a string length for the maximum error string length
  integer, parameter :: max_mtime_error_str_len = 132

  !> provides a string length for toString
  integer, parameter :: max_eventname_str_len = 132
  integer, parameter :: max_event_str_len = 512

  !> provides a string length for toString
  integer, parameter :: max_groupname_str_len = 132

contains
  
end module mtime_constants
