  ! ================================================================================
  ! timedelta section:
  ! ================================================================================

  ! constructor for timedelta string
  !
  TYPE(t_timedelta) FUNCTION t_timedelta_assign_string(td_string) !OK-tested
    CHARACTER(len=*), INTENT(in) :: td_string
    TYPE(timedelta), POINTER     :: td_tmp
    TYPE(c_ptr) :: c_pointer

    c_pointer = my_newtimedeltafromstring(TRIM(ADJUSTL(td_string))//c_null_char)
    IF (.NOT. c_ASSOCIATED(c_pointer)) THEN
       CALL handle_errno(5 * 100 + 1, __FILE__, __LINE__)
       t_timedelta_assign_string%td%sign = '?'
    ELSE
       CALL c_f_POINTER(c_pointer, td_tmp)
       t_timedelta_assign_string%td = td_tmp
       t_timedelta_assign_string%td%sign = td_tmp%sign
       CALL my_deallocatetimedelta(c_pointer)
    END IF
  END FUNCTION t_timedelta_assign_string

  ! constructor for integer milliseconds (integer)
  !
  TYPE(t_timedelta) FUNCTION t_timedelta_assign_ms(td_ms)
    INTEGER, INTENT(in)                  :: td_ms
    CHARACTER(len=max_timedelta_str_len) :: td_string
    TYPE(c_ptr)                          :: c_pointer, dummy_pointer
    TYPE(timedelta), POINTER             :: td_tmp
    INTEGER                              :: i       
    
    td_string = ""
    dummy_pointer = my_getptstringfromms(INT(td_ms,c_int64_t), td_string)
    CALL handle_errno(.NOT. c_ASSOCIATED(dummy_pointer), 5 * 100 + 11, __FILE__, __LINE__)
    char_loop: DO i = 1 , LEN(td_string)
       IF (td_string(i:i) == c_null_char) EXIT char_loop
    END DO char_loop
    td_string(i:LEN(td_string)) = ' '
    c_pointer = my_newtimedeltafromstring(td_string)
    CALL handle_errno(.NOT. c_ASSOCIATED(c_pointer), 4 * 100 + 6, __FILE__, __LINE__)
    CALL C_F_POINTER(c_pointer, td_tmp)
    t_timedelta_assign_ms%td = td_tmp
    CALL my_deallocatetimedelta(c_pointer)
  END FUNCTION t_timedelta_assign_ms

  ! constructor for integer milliseconds (integer)
  !
  TYPE(t_timedelta) FUNCTION t_timedelta_assign_ms_i8(td_ms)
    INTEGER(c_int64_t), INTENT(in)       :: td_ms
    CHARACTER(len=max_timedelta_str_len) :: td_string
    TYPE(c_ptr)                          :: c_pointer, dummy_pointer
    TYPE(timedelta), POINTER             :: td_tmp
    INTEGER                              :: i       
    
    td_string = ""
    dummy_pointer = my_getptstringfromms(td_ms, td_string)
    CALL handle_errno(.NOT. c_ASSOCIATED(dummy_pointer), 5 * 100 + 11, __FILE__, __LINE__)
    char_loop: DO i = 1 , LEN(td_string)
       IF (td_string(i:i) == c_null_char) EXIT char_loop
    END DO char_loop
    td_string(i:LEN(td_string)) = ' '
    c_pointer = my_newtimedeltafromstring(td_string)
    CALL handle_errno(.NOT. c_ASSOCIATED(c_pointer), 4 * 100 + 6, __FILE__, __LINE__)
    CALL C_F_POINTER(c_pointer, td_tmp)
    t_timedelta_assign_ms_i8%td = td_tmp
    CALL my_deallocatetimedelta(c_pointer)
  END FUNCTION t_timedelta_assign_ms_i8

  ! constructor for integer seconds (integer)
  !
  TYPE(t_timedelta) FUNCTION t_timedelta_assign_sec(td_sec)
    INTEGER, INTENT(in) :: td_sec
    t_timedelta_assign_sec = t_timedelta_assign_ms(td_sec*1000)
  END FUNCTION t_timedelta_assign_sec

  ! constructor for integer seconds (integer)
  !
  TYPE(t_timedelta) FUNCTION t_timedelta_assign_sec_i8(td_sec)
    INTEGER(c_int64_t), INTENT(in) :: td_sec
    t_timedelta_assign_sec_i8 = t_timedelta_assign_ms_i8(td_sec*1000)
  END FUNCTION t_timedelta_assign_sec_i8


  LOGICAL FUNCTION t_timedelta_equal(this, td)
    CLASS (t_timedelta), TARGET, INTENT(in) :: this
    CLASS (t_timedelta), TARGET, INTENT(in) :: td
    INTEGER(c_int) :: ret
    ret = my_comparetimedelta(C_LOC(this%td), C_LOC(td%td))
    IF (ret == 0) THEN
      t_timedelta_equal = .TRUE.
    ELSE
      t_timedelta_equal = .FALSE.
    ENDIF
  END FUNCTION t_timedelta_equal

  LOGICAL FUNCTION t_timedelta_not_equal(this, td)
    CLASS (t_timedelta), TARGET, INTENT(in) :: this
    CLASS (t_timedelta), TARGET, INTENT(in) :: td
    INTEGER(c_int) :: ret
    ret = my_comparetimedelta(C_LOC(this%td), C_LOC(td%td))    
    IF (ret /= 0) THEN
      t_timedelta_not_equal = .TRUE.
    ELSE
      t_timedelta_not_equal = .FALSE.   
    ENDIF
  END FUNCTION t_timedelta_not_equal

  LOGICAL FUNCTION t_timedelta_less_than(this, td)
    CLASS (t_timedelta), TARGET, INTENT(in) :: this
    CLASS (t_timedelta), TARGET, INTENT(in) :: td
    INTEGER(c_int) :: ret
    ret = my_comparetimedelta(C_LOC(this%td), C_LOC(td%td))        
    IF (ret == -1) THEN
      t_timedelta_less_than = .TRUE.
    ELSE
      t_timedelta_less_than = .FALSE.
    ENDIF
  END FUNCTION t_timedelta_less_than

  LOGICAL FUNCTION t_timedelta_greater_than(this, td)
    CLASS (t_timedelta), TARGET, INTENT(in) :: this
    CLASS (t_timedelta), TARGET, INTENT(in) :: td
    INTEGER(c_int) :: ret
    ret = my_comparetimedelta(C_LOC(this%td), C_LOC(td%td))        
    IF (ret == 1) THEN
      t_timedelta_greater_than = .TRUE.
    ELSE
      t_timedelta_greater_than = .FALSE.   
    ENDIF
  END FUNCTION t_timedelta_greater_than

  LOGICAL FUNCTION t_timedelta_less_than_or_equal(this, td)
    CLASS (t_timedelta), TARGET, INTENT(in) :: this
    CLASS (t_timedelta), TARGET, INTENT(in) :: td
    INTEGER(c_int) :: ret
    ret = my_comparetimedelta(C_LOC(this%td), C_LOC(td%td))        
    IF ((ret == 0) .OR. (ret == -1)) THEN
      t_timedelta_less_than_or_equal = .TRUE.
    ELSE
      t_timedelta_less_than_or_equal = .FALSE.   
    ENDIF
  END FUNCTION t_timedelta_less_than_or_equal
  
  LOGICAL FUNCTION t_timedelta_greater_than_or_equal(this, td)
    CLASS (t_timedelta), TARGET, INTENT(in) :: this
    CLASS (t_timedelta), TARGET, INTENT(in) :: td
    INTEGER(c_int) :: ret
    ret = my_comparetimedelta(C_LOC(this%td), C_LOC(td%td))        
    IF ((ret == 0) .OR. (ret == 1)) THEN
      t_timedelta_greater_than_or_equal = .TRUE.
    ELSE
      t_timedelta_greater_than_or_equal = .FALSE.
    ENDIF
  END FUNCTION t_timedelta_greater_than_or_equal


  FUNCTION t_timedelta_scalar_multiply_long (this, lambda) RESULT(scaled_td)
    TYPE(t_timedelta), TARGET              :: scaled_td
    CLASS(t_timedelta), TARGET, INTENT(in) :: this
    INTEGER(c_int64_t),       INTENT(in)   :: lambda
    TYPE(c_ptr)                            :: td_pointer, c_pointer, dummy_pointer
    TYPE(timedelta), POINTER               :: td_tmp

    td_pointer = this%get_c_pointer()
    c_pointer = my_constructandcopytimedelta(td_pointer)
    CALL handle_errno(.NOT. c_ASSOCIATED(c_pointer), timedelta_newtimedeltafromconstructandcopy, __FILE__, __LINE__)
    dummy_pointer = my_elementwisescalarmultiplytimedelta(td_pointer, lambda, c_pointer)
    CALL handle_errno(.NOT. c_ASSOCIATED(dummy_pointer), general_arithmetic_error, __FILE__, __LINE__)
    CALL C_F_POINTER(c_pointer, td_tmp)
    scaled_td%td = td_tmp
    CALL my_deallocatetimedelta(c_pointer)    
  END FUNCTION t_timedelta_scalar_multiply_long

  FUNCTION t_timedelta_scalar_multiply_inv_long(lambda, this) RESULT(scaled_td)
    TYPE(t_timedelta), TARGET              :: scaled_td
    INTEGER(c_int64_t),       INTENT(in)   :: lambda
    CLASS(t_timedelta), TARGET, INTENT(in) :: this
    TYPE(c_ptr)                            :: td_pointer, c_pointer, dummy_pointer
    TYPE(timedelta), POINTER               :: td_tmp

    td_pointer = this%get_c_pointer()
    c_pointer = my_constructandcopytimedelta(td_pointer)
    CALL handle_errno(.NOT. c_ASSOCIATED(c_pointer), timedelta_newtimedeltafromconstructandcopy, __FILE__, __LINE__)
    dummy_pointer = my_elementwisescalarmultiplytimedelta(td_pointer, lambda, c_pointer)
    CALL handle_errno(.NOT. c_ASSOCIATED(dummy_pointer), general_arithmetic_error, __FILE__, __LINE__)
    CALL C_F_POINTER(c_pointer, td_tmp)
    scaled_td%td = td_tmp
    CALL my_deallocatetimedelta(c_pointer)    
  END FUNCTION t_timedelta_scalar_multiply_inv_long

  FUNCTION t_timedelta_scalar_multiply_int (this, lambda) RESULT(scaled_td) !OK-tested
    TYPE(t_timedelta), TARGET :: scaled_td
    INTEGER(c_int32_t),       INTENT(in) :: lambda
    CLASS(t_timedelta), TARGET, INTENT(in) :: this
    TYPE(c_ptr) :: dummy_ptr

    ! cast into real since in mtime int implementation scalar
    ! multiplication can not give a value in excess of 24 hours
    dummy_ptr = my_elementwisescalarmultiplytimedeltadp(c_LOC(this%td), REAL(lambda, c_double), c_LOC(scaled_td%td))
    IF (.NOT. c_ASSOCIATED(dummy_ptr)) THEN
      CALL handle_errno(0*100+2, __FILE__, __LINE__)
      scaled_td%td%sign = '!'
    ENDIF

  END FUNCTION t_timedelta_scalar_multiply_int

  FUNCTION t_timedelta_scalar_multiply_inv_int(lambda, this) RESULT(scaled_td)
    TYPE(t_timedelta), TARGET :: scaled_td
    INTEGER(c_int32_t),       INTENT(in) :: lambda
    CLASS(t_timedelta), TARGET, INTENT(in) :: this

    scaled_td = t_timedelta_scalar_multiply_int(this, lambda)
  END FUNCTION t_timedelta_scalar_multiply_inv_int

  FUNCTION t_timedelta_scalar_multiply_real (this, lambda) RESULT(scaled_td) !OK-tested
    TYPE(t_timedelta),  TARGET             :: scaled_td
    REAL(c_double),             INTENT(in) :: lambda
    CLASS(t_timedelta), TARGET, INTENT(in) :: this
    TYPE(c_ptr)                            :: dummy_ptr

    dummy_ptr = my_elementwisescalarmultiplytimedeltadp(c_LOC(this%td), lambda, c_LOC(scaled_td%td))
    IF (.NOT. c_ASSOCIATED(dummy_ptr)) THEN
      CALL handle_errno(0*100+2, __FILE__, __LINE__)
      scaled_td%td%sign = '!'
    ENDIF

  END FUNCTION t_timedelta_scalar_multiply_real

  FUNCTION t_timedelta_scalar_multiply_inv_real(lambda, this) RESULT(scaled_td)
    TYPE(t_timedelta), TARGET :: scaled_td
    REAL(c_double),       INTENT(in) :: lambda
    CLASS(t_timedelta), TARGET, INTENT(in) :: this

    scaled_td = t_timedelta_scalar_multiply_real(this, lambda)
  END FUNCTION t_timedelta_scalar_multiply_inv_real

  ! Convert t_timedelta object to string.
  !
  FUNCTION t_timedelta_toString(this) RESULT(string)
    CHARACTER(len=max_timedelta_str_len)  :: string
    CLASS (t_timedelta)                   :: this
    TYPE(c_ptr) :: c_pointer, dummy_ptr
    INTEGER :: i

    string = ""

    c_pointer = this%get_c_pointer()
    CALL handle_errno(.NOT. c_ASSOCIATED(c_pointer), 0 * 100 + 2, __FILE__, __LINE__)
    dummy_ptr = my_timedeltatostring(c_pointer, string)
    CALL handle_errno(.NOT. c_ASSOCIATED(dummy_ptr), 4 * 100 + 6, __FILE__, __LINE__)

    char_loop: DO i = 1 , LEN(string)
       IF (string(i:i) == c_null_char) EXIT char_loop
    END DO char_loop
    string(i:LEN(string)) = ' '

    CALL my_deallocatetimedelta(c_pointer) !deallocate timedelta
  END FUNCTION t_timedelta_toString

  FUNCTION t_timedelta_divideBy (this, divisor, referenceDateTime) RESULT(quotient)
    CLASS(t_timedelta), INTENT(in), TARGET  :: this
    TYPE(t_timedelta),  INTENT(in), TARGET  :: divisor
    TYPE(t_datetime),   INTENT(IN), TARGET  :: referenceDateTime
    TYPE(divisionquotienttimespan), TARGET  :: quotient
    TYPE(c_ptr)                             :: dummy_ptr

    dummy_ptr = my_divideTimeDelta(c_LOC(this%td), c_LOC(divisor%td), &
                      & c_LOC(referenceDateTime%dt), c_LOC(quotient))

    CALL handle_errno(.NOT. c_ASSOCIATED(dummy_ptr), general_arithmetic_error, &
                      __FILE__, __LINE__)
  END FUNCTION t_timedelta_divideBy

  FUNCTION t_timedelta_toSeconds (this, dt) RESULT(seconds)
    INTEGER(c_int64_t)             :: seconds
    CLASS(t_timedelta), INTENT(in) :: this
    TYPE(t_datetime),   INTENT(in) :: dt
    TYPE(c_ptr)                    :: td_pointer, dt_pointer

    td_pointer = this%get_c_pointer()
    dt_pointer = dt%get_c_pointer()
    seconds = my_gettotalsecondstimedelta(td_pointer, dt_pointer)
  END FUNCTION t_timedelta_toSeconds

  FUNCTION t_timedelta_toMilliSeconds (this, dt) RESULT(ms)
    INTEGER(c_int64_t)             :: ms
    CLASS(t_timedelta), INTENT(in) :: this
    TYPE(t_datetime),   INTENT(in) :: dt
    TYPE(c_ptr)                    :: td_pointer, dt_pointer

    td_pointer = this%get_c_pointer()
    dt_pointer = dt%get_c_pointer()
    ms = my_gettotalmillisecondstimedelta(td_pointer, dt_pointer)
  END FUNCTION t_timedelta_toMilliSeconds

  FUNCTION t_timedelta_toJulianDelta(this, dt) RESULT(jd)
    TYPE(t_juliandelta), TARGET          :: jd
    CLASS(t_timedelta), INTENT(in)       :: this
    TYPE(t_datetime), INTENT(in)         :: dt
    INTEGER                              :: errno
    TYPE(juliandelta),  POINTER          :: jd_tmp
    TYPE(c_ptr)                          :: c_pointer, jd_pointer, dt_pointer, td_pointer    

    td_pointer = this%get_c_pointer()
    dt_pointer = dt%get_c_pointer()
    jd_pointer = my_newjuliandelta('+', 0_c_int64_T, 0_c_int64_T)
    c_pointer = my_timeDeltaToJulianDelta(td_pointer, dt_pointer, jd_pointer)
    CALL c_f_POINTER(c_pointer, jd_tmp)
    jd%jd = jd_tmp
    CALL my_deallocateJuliandelta(jd_pointer)
  END FUNCTION t_timedelta_toJulianDelta

  FUNCTION t_julianDay_getDay (this) RESULT(d)
    CLASS(t_julianday), INTENT(in) :: this
    INTEGER(c_int64_t) :: d
    d = this%jd%day
  END FUNCTION t_julianDay_getDay

  FUNCTION t_julianday_getFractionOfDayInMS (this) RESULT(ms)
    CLASS(t_julianday), INTENT(in) :: this
    INTEGER(c_int64_t) :: ms
    ms = this%jd%ms
  END FUNCTION t_julianday_getFractionOfDayInMS

  FUNCTION t_julianday_toDateTime(this) RESULT(res)
    TYPE(t_datetime), TARGET  :: res
    CLASS(t_julianday)        :: this
    INTEGER                   :: errno
    TYPE(datetime), POINTER   :: dt_tmp  
    TYPE(c_ptr) :: c_pointer, jd_pointer, dt_pointer

    jd_pointer = this%get_c_pointer()
    dt_pointer = my_newdatetime("1970-01-01T00:00"//c_null_char)
    c_pointer = my_getdatetimefromjulianday(jd_pointer, dt_pointer)
    CALL c_f_POINTER(c_pointer, dt_tmp)
    res%dt = dt_tmp
    CALL my_deallocatedatetime(dt_pointer)
    CALL my_deallocatejulianday(jd_pointer)
  END FUNCTION t_julianday_toDateTime

  FUNCTION t_datetime_min(a,b) RESULT(res)
    TYPE(t_datetime) :: a,b
    TYPE(t_datetime) :: res

    IF (a > b) THEN
      res = b
    ELSE
      res = a
    END IF
  END FUNCTION t_datetime_min

  FUNCTION t_datetime_max(a,b) RESULT(res)
    TYPE(t_datetime) :: a,b
    TYPE(t_datetime) :: res

    IF (a > b) THEN
      res = a
    ELSE
      res = b
    END IF
  END FUNCTION t_datetime_max

  FUNCTION t_timedelta_get_c_pointer(this) RESULT(c_pointer)
    TYPE(c_ptr) :: c_pointer
    CLASS(t_timedelta) :: this
    CHARACTER(kind=c_char) ::c_sign

    c_sign = this%td%SIGN(1:1)
    c_pointer = my_newrawtimedelta(c_sign, INT(this%td%year,c_int64_t), this%td%month, this%td%day, &
         &                         this%td%hour, this%td%minute, this%td%second, this%td%ms)
    CALL handle_errno((.NOT. c_ASSOCIATED(c_pointer)), 5 * 100 + 2, __FILE__, __LINE__)
  END FUNCTION t_timedelta_get_c_pointer

  FUNCTION t_timedelta_addElementWise(this, td) RESULT(added_td)
    TYPE (t_timedelta)             :: added_td
    CLASS(t_timedelta), INTENT(IN) :: this
    TYPE (t_timedelta), INTENT(in) :: td
    TYPE (c_ptr)                   :: c_pointer1, c_pointer2, c_pointer3, dummy_ptr
    TYPE(timedelta),    POINTER    :: td_tmp

    c_pointer1 = this%get_c_pointer()
    c_pointer2 = td%get_c_pointer()
    c_pointer3 = td%get_c_pointer()

    dummy_ptr = my_elementwiseaddtimedeltatotimedelta(c_pointer1, c_pointer2, c_pointer3)
    CALL handle_errno(.NOT. C_ASSOCIATED(dummy_ptr), 0 * 100 + 2, __FILE__, __LINE__)
    CALL C_F_POINTER(c_pointer3, td_tmp)
    CALL my_deallocatedatetime(c_pointer1)
    CALL my_deallocatedatetime(c_pointer2)
    added_td%td = td_tmp
    CALL my_deallocatedatetime(c_pointer3)
  END FUNCTION t_timedelta_addElementWise
